# PDF

## What does this library?

This library provides a simple way to work with PDF files in Go.

It supports:

- [x] Boolean objects
- [x] Number objects
- [x] String literals
- [x] String hexadecimals
- [ ] Name objects
- [ ] Array objects
- [ ] Dictionary objects
- [ ] Stream objects
- [ ] Indirect objects
- [ ] Null objects
- 

Not supported:

- [ ] Encrypted PDFs

## Installation

```shell
go get gitlab.schukai.com/oss/libraries/go/documents/pdf
```


## Contributing

Merge requests are welcome. For major changes, please open an issue first to discuss what
you would like to change. **Please make sure to update tests as appropriate.**

Versioning is done with [SemVer](https://semver.org/).
Changelog is generated with [git-chglog](https://github.com/git-chglog/git-chglog#git-chglog)

Commit messages should follow the [Conventional Commits](https://www.conventionalcommits.org/en/v1.0.0/) specification.
Messages are started with a type, which is one of the following:

- **feat**: A new feature
- **fix**: A bug fix
- **doc**: Documentation only changes
- **refactor**: A code change that neither fixes a bug nor adds a feature
- **perf**: A code change that improves performance
- **test**: Adding missing or correcting existing tests
- **chore**: Other changes that don't modify src or test files

The footer would be used for a reference to an issue or a breaking change.

A commit that has a footer `BREAKING CHANGE:`, or appends a ! after the type/scope,
introduces a breaking API change (correlating with MAJOR in semantic versioning).
A BREAKING CHANGE can be part of commits of any type.

the following is an example of a commit message:

```text
feat: add 'extras' field
```

## License

This library is available under the [AGPL-3.0](https://choosealicense.com/licenses/agpl-3.0/) 
license for open-source projects. For commercial use, please reach out to us 
at [sales@schukai.com](mailto:sales@schukai.com).