package pdf

import "io"

type Parser struct {
	tokenizer *Tokenizer
}

func NewParser(r io.ReadSeeker) *Parser {
	return &Parser{
		tokenizer: NewTokenizer(r),
	}
}

func (p *Parser) Parse() *Parser {
	p.tokenizer.switchState(initialState{})
	return p
}

func (p *Parser) HasError() bool {
	return len(p.tokenizer.parseError) > 0
}

func (p *Parser) GetErrors() []error {
	return p.tokenizer.parseError
}
