package pdf

import (
	"os"
	"testing"
)

func TestNewParser(t *testing.T) {
	p := NewParser(nil)
	if p == nil {
		t.Errorf("Expected NewParser to return a non-nil value")
	}
}

func TestParser_Parse(t *testing.T) {

	files := []string{
		"pdf20-utf8-test.pdf",
		"Simple-PDF-2.0-file.pdf",
		"PDF-2.0-image-with-BPC.pdf",
		"PDF-2.0-UTF-8-string-and-annotation.pdf",
		"PDF-2.0-via-incremental-save.pdf",
		"PDF-2.0-with-offset-start.pdf",
		"PDF-2.0-with-page-level-output-intent.pdf",
	}

	for _, f := range files {
		t.Run("TestParser_Parse "+f, func(t *testing.T) {
			file, err := os.Open("assets/" + f)
			if err != nil {
				t.Errorf("Expected to open the file, got %v", err)
				return
			}

			p := NewParser(file)
			p.Parse()

			if p.HasError() == true {
				for _, e := range p.GetErrors() {
					t.Errorf("Expected no errors, got %v", e)
				}
			}
		})
	}

}
