package pdf

type endDictionaryObjectToken struct {
	tokenInternal
}

type endDictionaryObjectState struct {
	token *endDictionaryObjectToken
}

func (s endDictionaryObjectState) process(t *Tokenizer) {
	var err error
	var r []rune

	r, err = t.consumeNextRunes(2)
	if err != nil {
		t.raiseError(err)
		return
	}

	if len(r) != 2 || !isGreaterThanSign(r[0]) || !isGreaterThanSign(r[1]) {
		t.raiseError(errDictionaryObjectMustEndWithDoubleGreaterThanSign)
		return
	}

	t.emitToken(s.token)

}
