package pdf

type endOfIndirectObjectToken struct {
	tokenInternal
}

type endOfIndirectObjectState struct {
	token *endOfIndirectObjectToken
}

func (s endOfIndirectObjectState) process(t *Tokenizer) {

	var c rune
	var err error
	var value string

	for {

		c, err = t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if c != 'e' && c != 'n' && c != 'd' && c != 'o' && c != 'b' && c != 'j' {
			err := t.unread()
			if err != nil {
				t.raiseError(err)
				return
			}

			break
		}

		value += string(c)
	}

	if value != keywordEndObj {
		t.raiseError(ErrInvalidIndirectEndObjectKeyword)
		return
	}

	t.emitToken(s.token)

	return
}
