package pdf

import (
	"io"
	"testing"
)

func TestEndIndirectObjectStat_Process(t *testing.T) {

	tests := []struct {
		name          string
		input         string
		expectedState state
		expectedError error
		expectTokens  []tokenInterface
	}{
		{"empty", "", endOfIndirectObjectState{}, io.EOF, []tokenInterface{}},
		{"emd of stream", "endobj ",
			endOfIndirectObjectState{}, nil, []tokenInterface{&endOfIndirectObjectToken{}}},
	}

	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			tok := createTestTokenizerWithData(tt.input)
			tok.state = endOfIndirectObjectState{
				token: &endOfIndirectObjectToken{},
			}

			// Verarbeite den Tokenizer
			tok.state.process(tok)

			checkStateAgainstDef(t, tok, tt.expectedState)
			checkErrors(t, tok, tt.expectedError)
			checkTokenStack(t, tok, tt.expectTokens)

		})
	}
}
