package pdf

type endOfLineToken struct {
	tokenInternal
}

type endOfLineState struct {
	token *endOfLineToken
}

func (s endOfLineState) process(t *Tokenizer) {

	// The combination of a CARRIAGE RETURN followed
	// immediately by a LINE FEED shall be treated as one EOL marker.
	c, err := t.consumeNextRune()
	if err != nil {
		t.raiseError(err)
		return
	}

	if !isEndOfLine(c) {
		err = t.unread()
		if err != nil {
			t.raiseError(err)
			return
		}
	}

	t.emitToken(s.token)
}
