package pdf

type newlineState struct{}

func (s newlineState) process(t *Tokenizer) {

	c, err := t.consumeNextRune()
	if err != nil {
		t.raiseError(err)
		return
	}

	if isEndOfLine(c) {
		t.switchState(endOfLineState{
			token: &endOfLineToken{},
		})
		return
	}

	err = t.unread()
	if err != nil {
		t.raiseError(err)
		return
	}

	t.switchState(identifyLineTypeState{})
}
