package pdf

type pdfVersionToken struct {
	tokenInternal
	Version string
}

func (t *pdfVersionToken) emit() {
	// Spezifische Logik für pdfVersionToken, zusätzlich zum Standardverhalten
	t.Version = string(t.values)
	t.tokenInternal.emitFlag = true
}

type pdfVersionState struct {
	token *pdfVersionToken
}

func (s pdfVersionState) process(t *Tokenizer) {
	for {
		c, err := t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			t.emitToken(s.token)
			return
		}

		if isEndOfLine(c) {
			t.emitToken(s.token)

			t.switchState(endOfLineState{
				token: &endOfLineToken{},
			})

			break
		}

		s.token.values = append(s.token.values, c)
	}
}
