package pdf

type indirectObjectKeywordToken struct {
	tokenInternal
	value string
}

type readIndirectObjectKeywordState struct {
	token *indirectObjectKeywordToken
}

func (s readIndirectObjectKeywordState) process(t *Tokenizer) {

	var c rune
	var err error
	var value string

	for {

		c, err = t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if c != 'o' && c != 'b' && c != 'j' {
			break
		}

		value += string(c)
	}

	if value != "obj" {
		t.raiseError(ErrInvalidIndirectObjectKeyword)
		return
	}

	s.token.value = value
	t.emitToken(s.token)

	return

}
