package pdf

type nullToken struct {
	tokenInternal
	value string
}

type readNullObjectState struct {
	token *nullToken
}

func (s readNullObjectState) process(t *Tokenizer) {

	var c rune
	var err error
	var value string

	for {

		c, err = t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if c != 'n' && c != 'u' && c != 'l' {
			break
		}

		value += string(c)
	}

	if value != "null" {
		t.raiseError(ErrInvalidNull)
		return
	}

	s.token.value = value
	t.emitToken(s.token)

	return
}
