package pdf

import (
	"io"
	"testing"
)

func TestStateReadReferenceObject(t *testing.T) {

	tests := []struct {
		name          string
		input         string
		expectedState state
		expectedError error
		expectTokens  []tokenInterface
	}{
		{"empty", "", readReferenceObjectState{}, io.EOF, []tokenInterface{}},
		{"Reference", "R", readReferenceObjectState{}, nil, []tokenInterface{&referenceObjectToken{}}},
	}

	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			tok := createTestTokenizerWithData(tt.input)
			tok.state = readReferenceObjectState{
				token: &referenceObjectToken{},
			}

			// Verarbeite den Tokenizer
			tok.state.process(tok)

			checkStateAgainstDef(t, tok, tt.expectedState)
			checkErrors(t, tok, tt.expectedError)
			checkTokenStack(t, tok, tt.expectTokens)

		})
	}
}
