package pdf

type streamObjectToken struct {
	tokenInternal
	values []rune
}

type readStreamObjectState struct {
	token *streamObjectToken
}

func (s readStreamObjectState) process(t *Tokenizer) {

	var r []rune

	// store last 9 runes to check if we are at the end of the stream
	var last9Runes []rune

	for {

		c, err := t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		last9Runes = append(last9Runes, c)
		if len(last9Runes) > 9 {
			last9Runes = last9Runes[1:]
		}

		if string(last9Runes) == keywordEndStream {

			r = r[:len(r)-9]
			err := t.unreadCount(9)
			if err != nil {
				t.raiseError(err)
				return
			}

			s.token.values = r
			t.emitToken(s.token)

			t.switchState(endStreamObjectState{
				token: &endStreamObjectToken{
					tokenInternal: tokenInternal{},
				},
			})

			return
		}

		r = append(r, c)

	}

}
