package pdf

type xrefOffsetToken struct {
	tokenInternal
	byteOffsetXRef int64
}

type readXrefOffsetState struct {
	token *xrefOffsetToken
}

func (s readXrefOffsetState) process(t *Tokenizer) {

	for {
		c, err := t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if isEndOfLine(c) {
			t.switchState(endOfLineState{
				token: &endOfLineToken{},
			})

			t.switchState(byteOffsetOfLastCrossReferenceSectionState{
				token: s.token,
			})

			return
		}

		t.raiseError(ErrEndOfLineExpected)
		return

	}
}
