package pdf

import (
	"testing"
)

func TestXrefState(t *testing.T) {

	tests := []struct {
		name          string
		input         string
		expectedState state
		expectedError error
		expectTokens  []tokenInterface
	}{
		{"No end of line", "x", readXrefOffsetState{}, ErrEndOfLineExpected, []tokenInterface{}},
		{"end of line and offset", "\r\n1234\r\n", endOfLineState{}, nil, []tokenInterface{&endOfLineToken{}, &xrefOffsetToken{}, &endOfLineToken{}}},
	}

	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			tok := createTestTokenizerWithData(tt.input)
			tok.state = readXrefOffsetState{
				token: &xrefOffsetToken{},
			}

			// Verarbeite den Tokenizer
			tok.state.process(tok)

			checkStateAgainstDef(t, tok, tt.expectedState)
			checkErrors(t, tok, tt.expectedError)
			checkTokenStack(t, tok, tt.expectTokens)

		})
	}
}
