package pdf

import (
	"errors"
	"io"
)

type runBodyState struct{}

func (s runBodyState) process(t *Tokenizer) {

	for {
		t.switchState(newlineState{})

		lastToken := *t.peekToken()
		penultimateToken := t.penultimateToken()

		if len(t.parseError) == 1 && errors.Is(t.parseError[0], io.EOF) {
			if lastToken == nil {
				return
			}

			if penultimateToken == nil {
				return
			}

			if _, ok := penultimateToken.(*endOfFileToken); ok {
				t.parseError = nil
				return
			}
		}

		if len(t.parseError) > 0 {
			return
		}

		for _, err := range t.parseError {
			if errors.Is(err, io.EOF) {
				return
			}
		}

		if lastToken == nil {
			continue
		}

		switch lastToken.(type) {
		case *endOfFileToken:
			return

		}

	}
}
