package pdf

import (
	"testing"
)

func TestRunBodyState(t *testing.T) {

	tests := []struct {
		name          string
		input         string
		expectedState state
		expectedError error
		expectTokens  []tokenInterface
	}{
		{"Some Text with carriage return", "Some Text\r",
			endOfLineState{}, ErrInvalidIndirectObjectIdentifier,
			[]tokenInterface{
				&endOfLineToken{},
			}},
	}

	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			tok := createTestTokenizerWithData(tt.input)
			tok.state = runBodyState{}

			tok.state.process(tok)

			checkStateAgainstDef(t, tok, tt.expectedState)
			checkErrors(t, tok, tt.expectedError)
			checkTokenStack(t, tok, tt.expectTokens)

		})
	}
}
