package pdf

type startStartxrefToken struct {
	tokenInternal
}

type startStartXrefState struct {
	token *startStartxrefToken
}

func (s startStartXrefState) process(t *Tokenizer) {

	var c rune
	var err error
	var value string

	for {

		c, err = t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if c != 's' && c != 'a' && c != 'r' && c != 't' && c != 'x' && c != 'e' && c != 'f' {
			err := t.unread()
			if err != nil {
				t.raiseError(err)
				return
			}
			break
		}

		value += string(c)
	}

	if value != keywordStartXRef {
		t.raiseError(ErrInvalidStartXref)
		return
	}

	t.emitToken(s.token)

	// Switch to the state that reads the xref offset
	t.switchState(readXrefOffsetState{
		token: &xrefOffsetToken{},
	})

	return
}
