package pdf

type startStreamObjectToken struct {
	tokenInternal
}

type startStreamObjectState struct {
	token *startStreamObjectToken
}

func (s startStreamObjectState) process(t *Tokenizer) {
	var c rune
	var err error
	var value string

	for {

		c, err = t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if c != 's' && c != 't' && c != 'r' && c != 'e' && c != 'a' && c != 'm' {
			err := t.unread()
			if err != nil {
				t.raiseError(err)
				return
			}
			break
		}

		value += string(c)
	}

	if value != keywordStartStream {
		t.raiseError(ErrInvalidBoolean)
		return
	}

	t.emitToken(s.token)

	t.switchState(readStreamObjectState{
		token: &streamObjectToken{},
	})

	return
}
