package pdf

type startXrefToken struct {
	tokenInternal
}

type startXrefState struct {
	token *startXrefToken
}

func (s startXrefState) process(t *Tokenizer) {

	var c rune
	var err error
	var value string

	for {

		c, err = t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			return
		}

		if c != 'x' && c != 'r' && c != 'e' && c != 'f' {
			err := t.unread()
			if err != nil {
				t.raiseError(err)
				return
			}
			break
		}

		value += string(c)
	}

	if value != keywordXRef {
		t.raiseError(ErrInvalidXref)
		return
	}

	t.emitToken(s.token)

	t.switchState(readXrefState{
		token: &xrefToken{},
	})

	return
}
