package pdf

type whitespaceToken struct {
	tokenInternal
}

type whitespaceState struct {
	token *whitespaceToken
}

func (s whitespaceState) process(t *Tokenizer) {

	for {
		c, err := t.consumeNextRune()
		if err != nil {
			t.raiseError(err)
			t.emitToken(s.token)
			break
		}

		if isEndOfLine(c) {
			t.emitToken(s.token)
			t.switchState(endOfLineState{
				token: &endOfLineToken{},
			})
			break
		}

		if !isWhitespace(c) {
			t.emitToken(s.token)

			if err := t.unread(); err != nil {
				t.raiseError(err)
				return
			}

			break
		}

	}

}
