package pdf

type tokenInterface interface {
	isEmitted() bool
	emit()
	setByteOffset(int64)
}

type tokenInternal struct {
	emitFlag   bool
	values     []rune
	byteOffset int64
}

// implement the tokenInterface
func (t *tokenInternal) setByteOffset(offset int64) {
	t.byteOffset = offset
}

// implement the tokenInterface
func (t *tokenInternal) isEmitted() bool {
	return t.emitFlag
}

// implement the tokenInterface
func (t *tokenInternal) emit() {
	t.emitFlag = true
}
